function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { createStyledComponent } from '@cloudflare/style-container';
import { Div } from '@cloudflare/elements';
import { SELECTABLE_ID, EXPANDABLE_ID } from './Table';
import { Icon } from '@cloudflare/component-icon'; // A11Y-94: Button to trigger sorting for keyboard users.

var SortButton = createStyledComponent(() => ({
  background: 'none',
  color: 'inherit',
  alignItems: 'center',
  display: 'flex',
  border: 'none',
  padding: 0,
  font: 'inherit',
  cursor: 'pointer',
  outline: 'inherit',
  width: '100%',
  '&:focus': {
    outline: 'solid',
    outlineOffset: 3,
    outlineStyle: 'auto',
    outlineColor: 'gray.8'
  }
}), 'button');
var HeaderCellWrapper = createStyledComponent(_ref => {
  var {
    theme,
    isLoading,
    hasError,
    isEmpty,
    column
  } = _ref;
  return _objectSpread(_objectSpread({
    display: 'flex',
    alignItems: 'center',
    fontSize: 2,
    fontWeight: 600,
    color: 'gray.1',
    pl: 2,
    pr: 2,
    pb: 1,
    pt: 1,
    backgroundColor: theme.colors.background,
    borderBottom: "1px solid ".concat(theme.colors.gray[7]),
    transition: 'opacity 0.2s, background-color 0.2s'
  }, column.canSort ? {
    cursor: 'pointer'
  } : {}), {}, {
    '&:hover': {
      backgroundColor: column.canSort && !isLoading && !hasError && !isEmpty && theme.colors.gray[9]
    }
  });
}, 'th');

var HeaderCell = _ref2 => {
  var {
    column,
    isLoading,
    isEmpty,
    hasError,
    selectAllKey
  } = _ref2;
  return /*#__PURE__*/React.createElement(HeaderCellWrapper, _extends({}, column.getHeaderProps({
    style: _objectSpread({}, (column.id === SELECTABLE_ID || column.id === EXPANDABLE_ID) && {
      flex: '0 0 auto'
    })
  }), {
    "aria-sort": column.isSorted ? column.isSortedDesc ? 'descending' : 'ascending' : 'none',
    isLoading: isLoading,
    hasError: hasError,
    isEmpty: isEmpty,
    column: column
  }), column.canSort ? /*#__PURE__*/React.createElement(SortButton, {
    onClick: () => column.toggleSortBy()
  }, column.render('Header', {
    selectAllKey
  }), column.canSort && !isLoading && !hasError && !isEmpty && /*#__PURE__*/React.createElement(Div, {
    display: "flex",
    ml: 2,
    style: {
      transform: column.isSortedDesc ? 'rotate(-180deg)' : ''
    }
  }, column.isSorted ? /*#__PURE__*/React.createElement(Icon, {
    type: "caret-up",
    color: "gray.0",
    label: ""
  }) : /*#__PURE__*/React.createElement(Icon, {
    type: "reorder",
    color: "gray.0",
    label: "",
    size: 12
  }))) : column.render('Header', {
    selectAllKey
  }));
};

export default HeaderCell;